Choice (Java SE 26 & JDK 26)
Description: declaration: module: java.desktop, package: java.awt, class: Choice
Keywords: java.awt.Choice class

# Class Choice

java.lang.Object
java.awt.Component
java.awt.Choice

All Implemented Interfaces:
  `ImageObserver, ItemSelectable, MenuContainer, Serializable, Accessible`

public class Choice extends Component implements ItemSelectable, Accessible
The `Choice` class presents a pop-up menu of choices. The current choice is displayed as the title of the menu.

The following code example produces a pop-up menu:

>     Choice ColorChooser = new Choice();
>     ColorChooser.add("Green");
>     ColorChooser.add("Red");
>     ColorChooser.add("Blue");

After this choice menu has been added to a panel, it appears as follows in its normal state:

In the picture, `"Green"` is the current choice. Pushing the mouse button down on the object causes a menu to appear with the current choice highlighted.

Some native platforms do not support arbitrary resizing of `Choice` components and the behavior of `setSize()/getSize()` is bound by such limitations. Native GUI `Choice` components' size are often bound by such attributes as font size and length of items contained within the `Choice`.

Since:
  1.0
See Also:
  - Serialized Form

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `protected class`
  `Choice.AccessibleAWTChoice`
  This class implements accessibility support for the `Choice` class.

  ### Nested classes/interfaces declared in class Component

  `Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`
  Modifier and Type
  Class
  Description
  `protected class`
  `Component.AccessibleAWTComponent`
  Inner class of Component used to provide default support for accessibility.
  `static enum`
  `Component.BaselineResizeBehavior`
  Enumeration of the common ways the baseline of a component can change as the size changes.
  `protected class`
  `Component.BltBufferStrategy`
  Inner class for blitting offscreen surfaces to a component.
  `protected class`
  `Component.FlipBufferStrategy`
  Inner class for flipping buffers on a component.

- ## Field Summary

  ### Fields declared in class Component

  `accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`
  Modifier and Type
  Field
  Description
  `protected AccessibleContext`
  `accessibleContext`
  The `AccessibleContext` associated with this `Component`.
  `static final float`
  `BOTTOM_ALIGNMENT`
  Ease-of-use constant for `getAlignmentY`.
  `static final float`
  `CENTER_ALIGNMENT`
  Ease-of-use constant for `getAlignmentY` and `getAlignmentX`.
  `static final float`
  `LEFT_ALIGNMENT`
  Ease-of-use constant for `getAlignmentX`.
  `static final float`
  `RIGHT_ALIGNMENT`
  Ease-of-use constant for `getAlignmentX`.
  `static final float`
  `TOP_ALIGNMENT`
  Ease-of-use constant for `getAlignmentY()`.

  ### Fields declared in interface ImageObserver

  `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`
  Modifier and Type
  Field
  Description
  `static final int`
  `ABORT`
  This flag in the infoflags argument to imageUpdate indicates that an image which was being tracked asynchronously was aborted before production was complete.
  `static final int`
  `ALLBITS`
  This flag in the infoflags argument to imageUpdate indicates that a static image which was previously drawn is now complete and can be drawn again in its final form.
  `static final int`
  `ERROR`
  This flag in the infoflags argument to imageUpdate indicates that an image which was being tracked asynchronously has encountered an error.
  `static final int`
  `FRAMEBITS`
  This flag in the infoflags argument to imageUpdate indicates that another complete frame of a multi-frame image which was previously drawn is now available to be drawn again.
  `static final int`
  `HEIGHT`
  This flag in the infoflags argument to imageUpdate indicates that the height of the base image is now available and can be taken from the height argument to the imageUpdate callback method.
  `static final int`
  `PROPERTIES`
  This flag in the infoflags argument to imageUpdate indicates that the properties of the image are now available.
  `static final int`
  `SOMEBITS`
  This flag in the infoflags argument to imageUpdate indicates that more pixels needed for drawing a scaled variation of the image are available.
  `static final int`
  `WIDTH`
  This flag in the infoflags argument to imageUpdate indicates that the width of the base image is now available and can be taken from the width argument to the imageUpdate callback method.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Choice()`
  Creates a new choice menu.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `add(String item)`
  Adds an item to this `Choice` menu.
  `void`
  `addItem(String item)`
  Obsolete as of Java 2 platform v1.1.
  `void`
  `addItemListener(ItemListener l)`
  Adds the specified item listener to receive item events from this `Choice` menu.
  `void`
  `addNotify()`
  Creates the `Choice`'s peer.
  `int`
  `countItems()`
  Deprecated.
  As of JDK version 1.1, replaced by `getItemCount()`.
  `AccessibleContext`
  `getAccessibleContext()`
  Gets the `AccessibleContext` associated with this `Choice`.
  `String`
  `getItem(int index)`
  Gets the string at the specified index in this `Choice` menu.
  `int`
  `getItemCount()`
  Returns the number of items in this `Choice` menu.
  `ItemListener[]`
  `getItemListeners()`
  Returns an array of all the item listeners registered on this choice.
  `<T extends EventListener>
  T[]`
  `getListeners(Class<T> listenerType)`
  Returns an array of all the objects currently registered as `FooListener`s upon this `Choice`.
  `int`
  `getSelectedIndex()`
  Returns the index of the currently selected item.
  `String`
  `getSelectedItem()`
  Gets a representation of the current choice as a string.
  `Object[]`
  `getSelectedObjects()`
  Returns an array (length 1) containing the currently selected item.
  `void`
  `insert(String item, int index)`
  Inserts the item into this choice at the specified position.
  `protected String`
  `paramString()`
  Returns a string representing the state of this `Choice` menu.
  `protected void`
  `processEvent(AWTEvent e)`
  Processes events on this choice.
  `protected void`
  `processItemEvent(ItemEvent e)`
  Processes item events occurring on this `Choice` menu by dispatching them to any registered `ItemListener` objects.
  `void`
  `remove(int position)`
  Removes an item from the choice menu at the specified position.
  `void`
  `remove(String item)`
  Removes the first occurrence of `item` from the `Choice` menu.
  `void`
  `removeAll()`
  Removes all items from the choice menu.
  `void`
  `removeItemListener(ItemListener l)`
  Removes the specified item listener so that it no longer receives item events from this `Choice` menu.
  `void`
  `select(int pos)`
  Sets the selected item in this `Choice` menu to be the item at the specified position.
  `void`
  `select(String str)`
  Sets the selected item in this `Choice` menu to be the item whose name is equal to the specified string.

  ### Methods declared in class Component

  `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, bounds, checkImage, checkImage, coalesceEvents, contains, contains, createImage, createImage, createVolatileImage, createVolatileImage, deliverEvent, disable, disableEvents, dispatchEvent, doLayout, enable, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getAlignmentX, getAlignmentY, getBackground, getBaseline, getBaselineResizeBehavior, getBounds, getBounds, getColorModel, getComponentAt, getComponentAt, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeys, getFocusTraversalKeysEnabled, getFont, getFontMetrics, getForeground, getGraphics, getGraphicsConfiguration, getHeight, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocation, getLocationOnScreen, getMaximumSize, getMinimumSize, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPreferredSize, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getSize, getToolkit, getTreeLock, getWidth, getX, getY, gotFocus, handleEvent, hasFocus, hide, imageUpdate, inside, invalidate, isBackgroundSet, isCursorSet, isDisplayable, isDoubleBuffered, isEnabled, isFocusable, isFocusCycleRoot, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isOpaque, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, layout, list, list, list, list, list, locate, location, lostFocus, minimumSize, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paint, paintAll, postEvent, preferredSize, prepareImage, prepareImage, print, printAll, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processKeyEvent, processMouseEvent, processMouseMotionEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removeNotify, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, repaint, requestFocus, requestFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, requestFocusInWindow, reshape, resize, resize, revalidate, setBackground, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setEnabled, setFocusable, setFocusTraversalKeys, setFocusTraversalKeysEnabled, setFont, setForeground, setIgnoreRepaint, setLocale, setLocation, setLocation, setMaximumSize, setMinimumSize, setMixingCutoutShape, setName, setPreferredSize, setSize, setSize, setVisible, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle, update, validate`
  Modifier and Type
  Method
  Description
  `boolean`
  `action(Event evt, Object what)`
  Deprecated.
  As of JDK version 1.1, should register this component as ActionListener on component which fires action events.
  `void`
  `add(PopupMenu popup)`
  Adds the specified popup menu to the component.
  `void`
  `addComponentListener(ComponentListener l)`
  Adds the specified component listener to receive component events from this component.
  `void`
  `addFocusListener(FocusListener l)`
  Adds the specified focus listener to receive focus events from this component when this component gains input focus.
  `void`
  `addHierarchyBoundsListener(HierarchyBoundsListener l)`
  Adds the specified hierarchy bounds listener to receive hierarchy bounds events from this component when the hierarchy to which this container belongs changes.
  `void`
  `addHierarchyListener(HierarchyListener l)`
  Adds the specified hierarchy listener to receive hierarchy changed events from this component when the hierarchy to which this container belongs changes.
  `void`
  `addInputMethodListener(InputMethodListener l)`
  Adds the specified input method listener to receive input method events from this component.
  `void`
  `addKeyListener(KeyListener l)`
  Adds the specified key listener to receive key events from this component.
  `void`
  `addMouseListener(MouseListener l)`
  Adds the specified mouse listener to receive mouse events from this component.
  `void`
  `addMouseMotionListener(MouseMotionListener l)`
  Adds the specified mouse motion listener to receive mouse motion events from this component.
  `void`
  `addMouseWheelListener(MouseWheelListener l)`
  Adds the specified mouse wheel listener to receive mouse wheel events from this component.
  `void`
  `addPropertyChangeListener(PropertyChangeListener listener)`
  Adds a PropertyChangeListener to the listener list.
  `void`
  `addPropertyChangeListener(String propertyName, PropertyChangeListener listener)`
  Adds a PropertyChangeListener to the listener list for a specific property.
  `void`
  `applyComponentOrientation(ComponentOrientation orientation)`
  Sets the `ComponentOrientation` property of this component and all components contained within it.
  `boolean`
  `areFocusTraversalKeysSet(int id)`
  Returns whether the Set of focus traversal keys for the given focus traversal operation has been explicitly defined for this Component.
  `Rectangle`
  `bounds()`
  Deprecated.
  As of JDK version 1.1, replaced by `getBounds()`.
  `int`
  `checkImage(Image image, int width, int height, ImageObserver observer)`
  Returns the status of the construction of a screen representation of the specified image.
  `int`
  `checkImage(Image image, ImageObserver observer)`
  Returns the status of the construction of a screen representation of the specified image.
  `protected AWTEvent`
  `coalesceEvents(AWTEvent existingEvent, AWTEvent newEvent)`
  Potentially coalesce an event being posted with an existing event.
  `boolean`
  `contains(int x, int y)`
  Checks whether this component "contains" the specified point, where `x` and `y` are defined to be relative to the coordinate system of this component.
  `boolean`
  `contains(Point p)`
  Checks whether this component "contains" the specified point, where the point's x and y coordinates are defined to be relative to the coordinate system of this component.
  `Image`
  `createImage(int width, int height)`
  Creates an off-screen drawable image to be used for double buffering.
  `Image`
  `createImage(ImageProducer producer)`
  Creates an image from the specified image producer.
  `VolatileImage`
  `createVolatileImage(int width, int height)`
  Creates a volatile off-screen drawable image to be used for double buffering.
  `VolatileImage`
  `createVolatileImage(int width, int height, ImageCapabilities caps)`
  Creates a volatile off-screen drawable image, with the given capabilities.
  `void`
  `deliverEvent(Event e)`
  Deprecated.
  As of JDK version 1.1, replaced by `dispatchEvent(AWTEvent e)`.
  `void`
  `disable()`
  Deprecated.
  As of JDK version 1.1, replaced by `setEnabled(boolean)`.
  `protected final void`
  `disableEvents(long eventsToDisable)`
  Disables the events defined by the specified event mask parameter from being delivered to this component.
  `final void`
  `dispatchEvent(AWTEvent e)`
  Dispatches an event to this component or one of its sub components.
  `void`
  `doLayout()`
  Prompts the layout manager to lay out this component.
  `void`
  `enable()`
  Deprecated.
  As of JDK version 1.1, replaced by `setEnabled(boolean)`.
  `void`
  `enable(boolean b)`
  Deprecated.
  As of JDK version 1.1, replaced by `setEnabled(boolean)`.
  `protected final void`
  `enableEvents(long eventsToEnable)`
  Enables the events defined by the specified event mask parameter to be delivered to this component.
  `void`
  `enableInputMethods(boolean enable)`
  Enables or disables input method support for this component.
  `protected void`
  `firePropertyChange(String propertyName, boolean oldValue, boolean newValue)`
  Support for reporting bound property changes for boolean properties.
  `void`
  `firePropertyChange(String propertyName, byte oldValue, byte newValue)`
  Reports a bound property change.
  `void`
  `firePropertyChange(String propertyName, char oldValue, char newValue)`
  Reports a bound property change.
  `void`
  `firePropertyChange(String propertyName, double oldValue, double newValue)`
  Reports a bound property change.
  `void`
  `firePropertyChange(String propertyName, float oldValue, float newValue)`
  Reports a bound property change.
  `protected void`
  `firePropertyChange(String propertyName, int oldValue, int newValue)`
  Support for reporting bound property changes for integer properties.
  `void`
  `firePropertyChange(String propertyName, long oldValue, long newValue)`
  Reports a bound property change.
  `void`
  `firePropertyChange(String propertyName, short oldValue, short newValue)`
  Reports a bound property change.
  `protected void`
  `firePropertyChange(String propertyName, Object oldValue, Object newValue)`
  Support for reporting bound property changes for Object properties.
  `float`
  `getAlignmentX()`
  Returns the alignment along the x axis.
  `float`
  `getAlignmentY()`
  Returns the alignment along the y axis.
  `Color`
  `getBackground()`
  Gets the background color of this component.
  `int`
  `getBaseline(int width, int height)`
  Returns the baseline.
  `Component.BaselineResizeBehavior`
  `getBaselineResizeBehavior()`
  Returns an enum indicating how the baseline of the component changes as the size changes.
  `Rectangle`
  `getBounds()`
  Gets the bounds of this component in the form of a `Rectangle` object.
  `Rectangle`
  `getBounds(Rectangle rv)`
  Stores the bounds of this component into "return value" rv and return rv.
  `ColorModel`
  `getColorModel()`
  Gets the instance of `ColorModel` used to display the component on the output device.
  `Component`
  `getComponentAt(int x, int y)`
  Determines if this component or one of its immediate subcomponents contains the (x, y) location, and if so, returns the containing component.
  `Component`
  `getComponentAt(Point p)`
  Returns the component or subcomponent that contains the specified point.
  `ComponentListener[]`
  `getComponentListeners()`
  Returns an array of all the component listeners registered on this component.
  `ComponentOrientation`
  `getComponentOrientation()`
  Retrieves the language-sensitive orientation that is to be used to order the elements or text within this component.
  `Cursor`
  `getCursor()`
  Gets the cursor set in the component.
  `DropTarget`
  `getDropTarget()`
  Gets the `DropTarget` associated with this `Component`.
  `Container`
  `getFocusCycleRootAncestor()`
  Returns the Container which is the focus cycle root of this Component's focus traversal cycle.
  `FocusListener[]`
  `getFocusListeners()`
  Returns an array of all the focus listeners registered on this component.
  `Set<AWTKeyStroke>`
  `getFocusTraversalKeys(int id)`
  Returns the Set of focus traversal keys for a given traversal operation for this Component.
  `boolean`
  `getFocusTraversalKeysEnabled()`
  Returns whether focus traversal keys are enabled for this Component.
  `Font`
  `getFont()`
  Gets the font of this component.
  `FontMetrics`
  `getFontMetrics(Font font)`
  Gets the font metrics for the specified font.
  `Color`
  `getForeground()`
  Gets the foreground color of this component.
  `Graphics`
  `getGraphics()`
  Creates a graphics context for this component.
  `GraphicsConfiguration`
  `getGraphicsConfiguration()`
  Gets the `GraphicsConfiguration` associated with this `Component`.
  `int`
  `getHeight()`
  Returns the current height of this component.
  `HierarchyBoundsListener[]`
  `getHierarchyBoundsListeners()`
  Returns an array of all the hierarchy bounds listeners registered on this component.
  `HierarchyListener[]`
  `getHierarchyListeners()`
  Returns an array of all the hierarchy listeners registered on this component.
  `boolean`
  `getIgnoreRepaint()`
  Returns whether or not paint messages received from the operating system should be ignored.
  `InputContext`
  `getInputContext()`
  Gets the input context used by this component for handling the communication with input methods when text is entered in this component.
  `InputMethodListener[]`
  `getInputMethodListeners()`
  Returns an array of all the input method listeners registered on this component.
  `InputMethodRequests`
  `getInputMethodRequests()`
  Gets the input method request handler which supports requests from input methods for this component.
  `KeyListener[]`
  `getKeyListeners()`
  Returns an array of all the key listeners registered on this component.
  `Locale`
  `getLocale()`
  Gets the locale of this component.
  `Point`
  `getLocation()`
  Gets the location of this component in the form of a point specifying the component's top-left corner.
  `Point`
  `getLocation(Point rv)`
  Stores the x,y origin of this component into "return value" rv and return rv.
  `Point`
  `getLocationOnScreen()`
  Gets the location of this component in the form of a point specifying the component's top-left corner in the screen's coordinate space.
  `Dimension`
  `getMaximumSize()`
  Gets the maximum size of this component.
  `Dimension`
  `getMinimumSize()`
  Gets the minimum size of this component.
  `MouseListener[]`
  `getMouseListeners()`
  Returns an array of all the mouse listeners registered on this component.
  `MouseMotionListener[]`
  `getMouseMotionListeners()`
  Returns an array of all the mouse motion listeners registered on this component.
  `Point`
  `getMousePosition()`
  Returns the position of the mouse pointer in this `Component`'s coordinate space if the `Component` is directly under the mouse pointer, otherwise returns `null`.
  `MouseWheelListener[]`
  `getMouseWheelListeners()`
  Returns an array of all the mouse wheel listeners registered on this component.
  `String`
  `getName()`
  Gets the name of the component.
  `Container`
  `getParent()`
  Gets the parent of this component.
  `Dimension`
  `getPreferredSize()`
  Gets the preferred size of this component.
  `PropertyChangeListener[]`
  `getPropertyChangeListeners()`
  Returns an array of all the property change listeners registered on this component.
  `PropertyChangeListener[]`
  `getPropertyChangeListeners(String propertyName)`
  Returns an array of all the listeners which have been associated with the named property.
  `Dimension`
  `getSize()`
  Returns the size of this component in the form of a `Dimension` object.
  `Dimension`
  `getSize(Dimension rv)`
  Stores the width/height of this component into "return value" rv and return rv.
  `Toolkit`
  `getToolkit()`
  Gets the toolkit of this component.
  `final Object`
  `getTreeLock()`
  Gets this component's locking object (the object that owns the thread synchronization monitor) for AWT component-tree and layout operations.
  `int`
  `getWidth()`
  Returns the current width of this component.
  `int`
  `getX()`
  Returns the current x coordinate of the components origin.
  `int`
  `getY()`
  Returns the current y coordinate of the components origin.
  `boolean`
  `gotFocus(Event evt, Object what)`
  Deprecated.
  As of JDK version 1.1, replaced by processFocusEvent(FocusEvent).
  `boolean`
  `handleEvent(Event evt)`
  Deprecated.
  As of JDK version 1.1 replaced by processEvent(AWTEvent).
  `boolean`
  `hasFocus()`
  Returns `true` if this `Component` is the focus owner.
  `void`
  `hide()`
  Deprecated.
  As of JDK version 1.1, replaced by `setVisible(boolean)`.
  `boolean`
  `imageUpdate(Image img, int infoflags, int x, int y, int w, int h)`
  Repaints the component when the image has changed.
  `boolean`
  `inside(int x, int y)`
  Deprecated.
  As of JDK version 1.1, replaced by contains(int, int).
  `void`
  `invalidate()`
  Invalidates this component and its ancestors.
  `boolean`
  `isBackgroundSet()`
  Returns whether the background color has been explicitly set for this Component.
  `boolean`
  `isCursorSet()`
  Returns whether the cursor has been explicitly set for this Component.
  `boolean`
  `isDisplayable()`
  Determines whether this component is displayable.
  `boolean`
  `isDoubleBuffered()`
  Returns true if this component is painted to an offscreen image ("buffer") that's copied to the screen later.
  `boolean`
  `isEnabled()`
  Determines whether this component is enabled.
  `boolean`
  `isFocusable()`
  Returns whether this Component can be focused.
  `boolean`
  `isFocusCycleRoot(Container container)`
  Returns whether the specified Container is the focus cycle root of this Component's focus traversal cycle.
  `boolean`
  `isFocusOwner()`
  Returns `true` if this `Component` is the focus owner.
  `boolean`
  `isFocusTraversable()`
  Deprecated.
  As of 1.4, replaced by `isFocusable()`.
  `boolean`
  `isFontSet()`
  Returns whether the font has been explicitly set for this Component.
  `boolean`
  `isForegroundSet()`
  Returns whether the foreground color has been explicitly set for this Component.
  `boolean`
  `isLightweight()`
  A lightweight component doesn't have a native toolkit peer.
  `boolean`
  `isMaximumSizeSet()`
  Returns true if the maximum size has been set to a non-`null` value otherwise returns false.
  `boolean`
  `isMinimumSizeSet()`
  Returns whether or not `setMinimumSize` has been invoked with a non-null value.
  `boolean`
  `isOpaque()`
  Returns true if this component is completely opaque, returns false by default.
  `boolean`
  `isPreferredSizeSet()`
  Returns true if the preferred size has been set to a non-`null` value otherwise returns false.
  `boolean`
  `isShowing()`
  Determines whether this component is showing on screen.
  `boolean`
  `isValid()`
  Determines whether this component is valid.
  `boolean`
  `isVisible()`
  Determines whether this component should be visible when its parent is visible.
  `boolean`
  `keyDown(Event evt, int key)`
  Deprecated.
  As of JDK version 1.1, replaced by processKeyEvent(KeyEvent).
  `boolean`
  `keyUp(Event evt, int key)`
  Deprecated.
  As of JDK version 1.1, replaced by processKeyEvent(KeyEvent).
  `void`
  `layout()`
  Deprecated.
  As of JDK version 1.1, replaced by `doLayout()`.
  `void`
  `list()`
  Prints a listing of this component to the standard system output stream `System.out`.
  `void`
  `list(PrintStream out)`
  Prints a listing of this component to the specified output stream.
  `void`
  `list(PrintStream out, int indent)`
  Prints out a list, starting at the specified indentation, to the specified print stream.
  `void`
  `list(PrintWriter out)`
  Prints a listing to the specified print writer.
  `void`
  `list(PrintWriter out, int indent)`
  Prints out a list, starting at the specified indentation, to the specified print writer.
  `Component`
  `locate(int x, int y)`
  Deprecated.
  As of JDK version 1.1, replaced by getComponentAt(int, int).
  `Point`
  `location()`
  Deprecated.
  As of JDK version 1.1, replaced by `getLocation()`.
  `boolean`
  `lostFocus(Event evt, Object what)`
  Deprecated.
  As of JDK version 1.1, replaced by processFocusEvent(FocusEvent).
  `Dimension`
  `minimumSize()`
  Deprecated.
  As of JDK version 1.1, replaced by `getMinimumSize()`.
  `boolean`
  `mouseDown(Event evt, int x, int y)`
  Deprecated.
  As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).
  `boolean`
  `mouseDrag(Event evt, int x, int y)`
  Deprecated.
  As of JDK version 1.1, replaced by processMouseMotionEvent(MouseEvent).
  `boolean`
  `mouseEnter(Event evt, int x, int y)`
  Deprecated.
  As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).
  `boolean`
  `mouseExit(Event evt, int x, int y)`
  Deprecated.
  As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).
  `boolean`
  `mouseMove(Event evt, int x, int y)`
  Deprecated.
  As of JDK version 1.1, replaced by processMouseMotionEvent(MouseEvent).
  `boolean`
  `mouseUp(Event evt, int x, int y)`
  Deprecated.
  As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).
  `void`
  `move(int x, int y)`
  Deprecated.
  As of JDK version 1.1, replaced by `setLocation(int, int)`.
  `void`
  `nextFocus()`
  Deprecated.
  As of JDK version 1.1, replaced by transferFocus().
  `void`
  `paint(Graphics g)`
  Paints this component.
  `void`
  `paintAll(Graphics g)`
  Paints this component and all of its subcomponents.
  `boolean`
  `postEvent(Event e)`
  Deprecated.
  As of JDK version 1.1, replaced by dispatchEvent(AWTEvent).
  `Dimension`
  `preferredSize()`
  Deprecated.
  As of JDK version 1.1, replaced by `getPreferredSize()`.
  `boolean`
  `prepareImage(Image image, int width, int height, ImageObserver observer)`
  Prepares an image for rendering on this component at the specified width and height.
  `boolean`
  `prepareImage(Image image, ImageObserver observer)`
  Prepares an image for rendering on this component.
  `void`
  `print(Graphics g)`
  Prints this component.
  `void`
  `printAll(Graphics g)`
  Prints this component and all of its subcomponents.
  `protected void`
  `processComponentEvent(ComponentEvent e)`
  Processes component events occurring on this component by dispatching them to any registered `ComponentListener` objects.
  `protected void`
  `processFocusEvent(FocusEvent e)`
  Processes focus events occurring on this component by dispatching them to any registered `FocusListener` objects.
  `protected void`
  `processHierarchyBoundsEvent(HierarchyEvent e)`
  Processes hierarchy bounds events occurring on this component by dispatching them to any registered `HierarchyBoundsListener` objects.
  `protected void`
  `processHierarchyEvent(HierarchyEvent e)`
  Processes hierarchy events occurring on this component by dispatching them to any registered `HierarchyListener` objects.
  `protected void`
  `processInputMethodEvent(InputMethodEvent e)`
  Processes input method events occurring on this component by dispatching them to any registered `InputMethodListener` objects.
  `protected void`
  `processKeyEvent(KeyEvent e)`
  Processes key events occurring on this component by dispatching them to any registered `KeyListener` objects.
  `protected void`
  `processMouseEvent(MouseEvent e)`
  Processes mouse events occurring on this component by dispatching them to any registered `MouseListener` objects.
  `protected void`
  `processMouseMotionEvent(MouseEvent e)`
  Processes mouse motion events occurring on this component by dispatching them to any registered `MouseMotionListener` objects.
  `protected void`
  `processMouseWheelEvent(MouseWheelEvent e)`
  Processes mouse wheel events occurring on this component by dispatching them to any registered `MouseWheelListener` objects.
  `void`
  `remove(MenuComponent popup)`
  Removes the specified popup menu from the component.
  `void`
  `removeComponentListener(ComponentListener l)`
  Removes the specified component listener so that it no longer receives component events from this component.
  `void`
  `removeFocusListener(FocusListener l)`
  Removes the specified focus listener so that it no longer receives focus events from this component.
  `void`
  `removeHierarchyBoundsListener(HierarchyBoundsListener l)`
  Removes the specified hierarchy bounds listener so that it no longer receives hierarchy bounds events from this component.
  `void`
  `removeHierarchyListener(HierarchyListener l)`
  Removes the specified hierarchy listener so that it no longer receives hierarchy changed events from this component.
  `void`
  `removeInputMethodListener(InputMethodListener l)`
  Removes the specified input method listener so that it no longer receives input method events from this component.
  `void`
  `removeKeyListener(KeyListener l)`
  Removes the specified key listener so that it no longer receives key events from this component.
  `void`
  `removeMouseListener(MouseListener l)`
  Removes the specified mouse listener so that it no longer receives mouse events from this component.
  `void`
  `removeMouseMotionListener(MouseMotionListener l)`
  Removes the specified mouse motion listener so that it no longer receives mouse motion events from this component.
  `void`
  `removeMouseWheelListener(MouseWheelListener l)`
  Removes the specified mouse wheel listener so that it no longer receives mouse wheel events from this component.
  `void`
  `removeNotify()`
  Makes this `Component` undisplayable by destroying it native screen resource.
  `void`
  `removePropertyChangeListener(PropertyChangeListener listener)`
  Removes a PropertyChangeListener from the listener list.
  `void`
  `removePropertyChangeListener(String propertyName, PropertyChangeListener listener)`
  Removes a `PropertyChangeListener` from the listener list for a specific property.
  `void`
  `repaint()`
  Repaints this component.
  `void`
  `repaint(int x, int y, int width, int height)`
  Repaints the specified rectangle of this component.
  `void`
  `repaint(long tm)`
  Repaints the component.
  `void`
  `repaint(long tm, int x, int y, int width, int height)`
  Repaints the specified rectangle of this component within `tm` milliseconds.
  `void`
  `requestFocus()`
  Requests that this Component get the input focus, and that this Component's top-level ancestor become the focused Window.
  `protected boolean`
  `requestFocus(boolean temporary)`
  Requests that this `Component` get the input focus, and that this `Component`'s top-level ancestor become the focused `Window`.
  `protected boolean`
  `requestFocus(boolean temporary, FocusEvent.Cause cause)`
  Requests by the reason of `cause` that this `Component` get the input focus, and that this `Component`'s top-level ancestor become the focused `Window`.
  `void`
  `requestFocus(FocusEvent.Cause cause)`
  Requests by the reason of `cause` that this Component get the input focus, and that this Component's top-level ancestor become the focused Window.
  `boolean`
  `requestFocusInWindow()`
  Requests that this Component get the input focus, if this Component's top-level ancestor is already the focused Window.
  `protected boolean`
  `requestFocusInWindow(boolean temporary)`
  Requests that this `Component` get the input focus, if this `Component`'s top-level ancestor is already the focused `Window`.
  `boolean`
  `requestFocusInWindow(FocusEvent.Cause cause)`
  Requests by the reason of `cause` that this Component get the input focus, if this Component's top-level ancestor is already the focused Window.
  `void`
  `reshape(int x, int y, int width, int height)`
  Deprecated.
  As of JDK version 1.1, replaced by `setBounds(int, int, int, int)`.
  `void`
  `resize(int width, int height)`
  Deprecated.
  As of JDK version 1.1, replaced by `setSize(int, int)`.
  `void`
  `resize(Dimension d)`
  Deprecated.
  As of JDK version 1.1, replaced by `setSize(Dimension)`.
  `void`
  `revalidate()`
  Revalidates the component hierarchy up to the nearest validate root.
  `void`
  `setBackground(Color c)`
  Sets the background color of this component.
  `void`
  `setBounds(int x, int y, int width, int height)`
  Moves and resizes this component.
  `void`
  `setBounds(Rectangle r)`
  Moves and resizes this component to conform to the new bounding rectangle `r`.
  `void`
  `setComponentOrientation(ComponentOrientation o)`
  Sets the language-sensitive orientation that is to be used to order the elements or text within this component.
  `void`
  `setCursor(Cursor cursor)`
  Sets the cursor image to the specified cursor.
  `void`
  `setDropTarget(DropTarget dt)`
  Associate a `DropTarget` with this component.
  `void`
  `setEnabled(boolean b)`
  Enables or disables this component, depending on the value of the parameter `b`.
  `void`
  `setFocusable(boolean focusable)`
  Sets the focusable state of this Component to the specified value.
  `void`
  `setFocusTraversalKeys(int id, Set<? extends AWTKeyStroke> keystrokes)`
  Sets the focus traversal keys for a given traversal operation for this Component.
  `void`
  `setFocusTraversalKeysEnabled(boolean focusTraversalKeysEnabled)`
  Sets whether focus traversal keys are enabled for this Component.
  `void`
  `setFont(Font f)`
  Sets the font of this component.
  `void`
  `setForeground(Color c)`
  Sets the foreground color of this component.
  `void`
  `setIgnoreRepaint(boolean ignoreRepaint)`
  Sets whether or not paint messages received from the operating system should be ignored.
  `void`
  `setLocale(Locale l)`
  Sets the locale of this component.
  `void`
  `setLocation(int x, int y)`
  Moves this component to a new location.
  `void`
  `setLocation(Point p)`
  Moves this component to a new location.
  `void`
  `setMaximumSize(Dimension maximumSize)`
  Sets the maximum size of this component to a constant value.
  `void`
  `setMinimumSize(Dimension minimumSize)`
  Sets the minimum size of this component to a constant value.
  `void`
  `setMixingCutoutShape(Shape shape)`
  Sets a 'mixing-cutout' shape for this lightweight component.
  `void`
  `setName(String name)`
  Sets the name of the component to the specified string.
  `void`
  `setPreferredSize(Dimension preferredSize)`
  Sets the preferred size of this component to a constant value.
  `void`
  `setSize(int width, int height)`
  Resizes this component so that it has width `width` and height `height`.
  `void`
  `setSize(Dimension d)`
  Resizes this component so that it has width `d.width` and height `d.height`.
  `void`
  `setVisible(boolean b)`
  Shows or hides this component depending on the value of parameter `b`.
  `void`
  `show()`
  Deprecated.
  As of JDK version 1.1, replaced by `setVisible(boolean)`.
  `void`
  `show(boolean b)`
  Deprecated.
  As of JDK version 1.1, replaced by `setVisible(boolean)`.
  `Dimension`
  `size()`
  Deprecated.
  As of JDK version 1.1, replaced by `getSize()`.
  `String`
  `toString()`
  Returns a string representation of this component and its values.
  `void`
  `transferFocus()`
  Transfers the focus to the next component, as though this Component were the focus owner.
  `void`
  `transferFocusBackward()`
  Transfers the focus to the previous component, as though this Component were the focus owner.
  `void`
  `transferFocusUpCycle()`
  Transfers the focus up one focus traversal cycle.
  `void`
  `update(Graphics g)`
  Updates this component.
  `void`
  `validate()`
  Validates this component.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### Choice

    public Choice() throws HeadlessException
    Creates a new choice menu. The menu initially has no items in it.

    By default, the first item added to the choice menu becomes the selected item, until a different selection is made by the user by calling one of the `select` methods.

    Throws:
      `HeadlessException` - if GraphicsEnvironment.isHeadless() returns true
    See Also:
      - `GraphicsEnvironment.isHeadless()`
      - `select(int)`
      - `select(java.lang.String)`

- ## Method Details

  - ### addNotify

    public void addNotify()
    Creates the `Choice`'s peer. This peer allows us to change the look of the `Choice` without changing its functionality.
    Overrides:
      `addNotify` in class `Component`
    See Also:
      - `Component.getToolkit()`

  - ### getItemCount

    public int getItemCount()
    Returns the number of items in this `Choice` menu.
    Returns:
      the number of items in this `Choice` menu
    Since:
      1.1
    See Also:
      - `getItem(int)`

  - ### countItems

    @Deprecated public int countItems()
    Deprecated.
    As of JDK version 1.1, replaced by `getItemCount()`.
    Returns the number of items in this `Choice` menu.
    Returns:
      the number of items in this `Choice` menu

  - ### getItem

    public String getItem(int index)
    Gets the string at the specified index in this `Choice` menu.
    Parameters:
      `index` - the index at which to begin
    Returns:
      the item at the specified index
    See Also:
      - `getItemCount()`

  - ### add

    public void add(String item)
    Adds an item to this `Choice` menu.
    Parameters:
      `item` - the item to be added
    Throws:
      `NullPointerException` - if the item's value is `null`
    Since:
      1.1

  - ### addItem

    public void addItem(String item)
    Obsolete as of Java 2 platform v1.1. Please use the `add` method instead.

    Adds an item to this `Choice` menu.

    Parameters:
      `item` - the item to be added
    Throws:
      `NullPointerException` - if the item's value is equal to `null`

  - ### insert

    public void insert(String item, int index)
    Inserts the item into this choice at the specified position. Existing items at an index greater than or equal to `index` are shifted up by one to accommodate the new item. If `index` is greater than or equal to the number of items in this choice, `item` is added to the end of this choice.

    If the item is the first one being added to the choice, then the item becomes selected. Otherwise, if the selected item was one of the items shifted, the first item in the choice becomes the selected item. If the selected item was no among those shifted, it remains the selected item.

    Parameters:
      `item` - the non-`null` item to be inserted
      `index` - the position at which the item should be inserted
    Throws:
      `IllegalArgumentException` - if index is less than 0

  - ### remove

    public void remove(String item)
    Removes the first occurrence of `item` from the `Choice` menu. If the item being removed is the currently selected item, then the first item in the choice becomes the selected item. Otherwise, the currently selected item remains selected (and the selected index is updated accordingly).
    Parameters:
      `item` - the item to remove from this `Choice` menu
    Throws:
      `IllegalArgumentException` - if the item doesn't exist in the choice menu
    Since:
      1.1

  - ### remove

    public void remove(int position)
    Removes an item from the choice menu at the specified position. If the item being removed is the currently selected item, then the first item in the choice becomes the selected item. Otherwise, the currently selected item remains selected (and the selected index is updated accordingly).
    Parameters:
      `position` - the position of the item
    Throws:
      `IndexOutOfBoundsException` - if the specified position is out of bounds
    Since:
      1.1

  - ### removeAll

    public void removeAll()
    Removes all items from the choice menu.
    Since:
      1.1
    See Also:
      - `remove(String)`

  - ### getSelectedItem

    public String getSelectedItem()
    Gets a representation of the current choice as a string.
    Returns:
      a string representation of the currently selected item in this choice menu
    See Also:
      - `getSelectedIndex()`

  - ### getSelectedObjects

    public Object[] getSelectedObjects()
    Returns an array (length 1) containing the currently selected item. If this choice has no items, returns `null`.
    Specified by:
      `getSelectedObjects` in interface `ItemSelectable`
    Returns:
      the list of selected objects, or `null`
    See Also:
      - `ItemSelectable`

  - ### getSelectedIndex

    public int getSelectedIndex()
    Returns the index of the currently selected item. If nothing is selected, returns -1.
    Returns:
      the index of the currently selected item, or -1 if nothing is currently selected
    See Also:
      - `getSelectedItem()`

  - ### select

    public void select(int pos)
    Sets the selected item in this `Choice` menu to be the item at the specified position.

    Note that this method should be primarily used to initially select an item in this component. Programmatically calling this method will not trigger an `ItemEvent`. The only way to trigger an `ItemEvent` is by user interaction.

    Parameters:
      `pos` - the position of the selected item
    Throws:
      `IllegalArgumentException` - if the specified position is greater than the number of items or less than zero
    See Also:
      - `getSelectedItem()`
      - `getSelectedIndex()`

  - ### select

    public void select(String str)
    Sets the selected item in this `Choice` menu to be the item whose name is equal to the specified string. If more than one item matches (is equal to) the specified string, the one with the smallest index is selected.

    Note that this method should be primarily used to initially select an item in this component. Programmatically calling this method will not trigger an `ItemEvent`. The only way to trigger an `ItemEvent` is by user interaction.

    Parameters:
      `str` - the specified string
    See Also:
      - `getSelectedItem()`
      - `getSelectedIndex()`

  - ### addItemListener

    public void addItemListener(ItemListener l)
    Adds the specified item listener to receive item events from this `Choice` menu. Item events are sent in response to user input, but not in response to calls to `select`. If l is `null`, no exception is thrown and no action is performed.

    Refer to AWT Threading Issues for details on AWT's threading model.

    Specified by:
      `addItemListener` in interface `ItemSelectable`
    Parameters:
      `l` - the item listener
    Since:
      1.1
    See Also:
      - `removeItemListener(ItemListener)`
      - `getItemListeners()`
      - `select(int)`
      - `ItemEvent`
      - `ItemListener`

  - ### removeItemListener

    public void removeItemListener(ItemListener l)
    Removes the specified item listener so that it no longer receives item events from this `Choice` menu. If l is `null`, no exception is thrown and no action is performed.

    Refer to AWT Threading Issues for details on AWT's threading model.

    Specified by:
      `removeItemListener` in interface `ItemSelectable`
    Parameters:
      `l` - the item listener
    Since:
      1.1
    See Also:
      - `addItemListener(ItemListener)`
      - `getItemListeners()`
      - `ItemEvent`
      - `ItemListener`

  - ### getItemListeners

    public ItemListener[] getItemListeners()
    Returns an array of all the item listeners registered on this choice.
    Returns:
      all of this choice's `ItemListener`s or an empty array if no item listeners are currently registered
    Since:
      1.4
    See Also:
      - `addItemListener(ItemListener)`
      - `removeItemListener(ItemListener)`
      - `ItemEvent`
      - `ItemListener`

  - ### getListeners

    public <T extends EventListener> T[] getListeners(Class<T> listenerType)
    Returns an array of all the objects currently registered as `FooListener`s upon this `Choice`. `FooListener`s are registered using the `addFooListener` method.

    You can specify the `listenerType` argument with a class literal, such as `FooListener.class`. For example, you can query a `Choice c` for its item listeners with the following code:

        ItemListener[] ils = (ItemListener[])(c.getListeners(ItemListener.class));

    If no such listeners exist, this method returns an empty array.
    Overrides:
      `getListeners` in class `Component`
    Type Parameters:
      `T` - the type of the listeners
    Parameters:
      `listenerType` - the type of listeners requested; this parameter should specify an interface that descends from `java.util.EventListener`
    Returns:
      an array of all objects registered as `FooListener`s on this choice, or an empty array if no such listeners have been added
    Throws:
      `ClassCastException` - if `listenerType` doesn't specify a class or interface that implements `java.util.EventListener`
    Since:
      1.3
    See Also:
      - `getItemListeners()`

  - ### processEvent

    protected void processEvent(AWTEvent e)
    Processes events on this choice. If the event is an instance of `ItemEvent`, it invokes the `processItemEvent` method. Otherwise, it calls its superclass's `processEvent` method.

    Note that if the event parameter is `null` the behavior is unspecified and may result in an exception.

    Overrides:
      `processEvent` in class `Component`
    Parameters:
      `e` - the event
    Since:
      1.1
    See Also:
      - `ItemEvent`
      - `processItemEvent(ItemEvent)`

  - ### processItemEvent

    protected void processItemEvent(ItemEvent e)
    Processes item events occurring on this `Choice` menu by dispatching them to any registered `ItemListener` objects.

    This method is not called unless item events are enabled for this component. Item events are enabled when one of the following occurs:

    - An `ItemListener` object is registered via `addItemListener`.
    - Item events are enabled via `enableEvents`.

    Note that if the event parameter is `null` the behavior is unspecified and may result in an exception.

    Parameters:
      `e` - the item event
    Since:
      1.1
    See Also:
      - `ItemEvent`
      - `ItemListener`
      - `addItemListener(ItemListener)`
      - `Component.enableEvents(long)`

  - ### paramString

    protected String paramString()
    Returns a string representing the state of this `Choice` menu. This method is intended to be used only for debugging purposes, and the content and format of the returned string may vary between implementations. The returned string may be empty but may not be `null`.
    Overrides:
      `paramString` in class `Component`
    Returns:
      the parameter string of this `Choice` menu

  - ### getAccessibleContext

    public AccessibleContext getAccessibleContext()
    Gets the `AccessibleContext` associated with this `Choice`. For `Choice` components, the `AccessibleContext` takes the form of an `AccessibleAWTChoice`. A new `AccessibleAWTChoice` instance is created if necessary.
    Specified by:
      `getAccessibleContext` in interface `Accessible`
    Overrides:
      `getAccessibleContext` in class `Component`
    Returns:
      an `AccessibleAWTChoice` that serves as the `AccessibleContext` of this `Choice`
    Since:
      1.3